OpenShot Audio Library | OpenShotAudio: juce::DirectoryIterator Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::DirectoryIterator Class Referencefinal

`#include <juce_DirectoryIterator.h>`

## Public Member Functions
| DirectoryIterator (const File &directory, bool recursive, const String &pattern="*", int type=File::findFiles, File::FollowSymlinks follow=File::FollowSymlinks::yes)
bool | next ()
bool | next (bool *isDirectory, bool *isHidden, int64 *fileSize, Time *modTime, Time *creationTime, bool *isReadOnly)
const File & | getFile () const
float | getEstimatedProgress () const

## Detailed Description

This class is now deprecated in favour of RangedDirectoryIterator.

Searches through the files in a directory, returning each file that is found.

A DirectoryIterator will search through a directory and its subdirectories using a wildcard filepattern match.

The iterator keeps track of directories that it has previously traversed, and will skip any previously-seen directories in the case of cycles caused by symbolic links. It is also possible to avoid following symbolic links altogether.

If you may be scanning a large number of files, it's usually smarter to use this class than File::findChildFiles() because it allows you to stop at any time, rather than having to wait for the entire scan to finish before getting the results.

Please note that the order in which files are returned is completely undefined! They'll arrive in whatever order the underlying OS calls provide them, which will depend on the filesystem and other factors. If you need a sorted list, you'll need to manually sort them using your preferred comparator after collecting the list.

It also provides an estimate of its progress, using a (highly inaccurate!) algorithm.

See also
  RangedDirectoryIterator

Definition at line 55 of file juce_DirectoryIterator.h.

## Constructor & Destructor Documentation

## ◆ DirectoryIterator()

juce::DirectoryIterator::DirectoryIterator | ( | const File & | directory,
|  | bool | recursive,
|  | const String & | pattern = "*",
|  | int | type = File::findFiles,
|  | File::FollowSymlinks | follow = File::FollowSymlinks::yes )
| inline

Creates a DirectoryIterator for a given directory.

After creating one of these, call its next() method to get the first file - e.g.

DirectoryIterator iter (File ("/animals/mooses"), true, "*.moose");
while (iter.next())
{
File theFileItFound (iter.getFile());
... etc
}
juce::DirectoryIterator
Definition juce_DirectoryIterator.h:56
juce::File
Definition juce_File.h:45

See also
  RangedDirectoryIterator

Definition at line 77 of file juce_DirectoryIterator.h.

## Member Function Documentation

## ◆ getEstimatedProgress()

float juce::DirectoryIterator::getEstimatedProgress | ( |  | ) | const

Returns a guess of how far through the search the iterator has got.

Returns
  a value 0.0 to 1.0 to show the progress, although this won't be very accurate.

Definition at line 149 of file juce_DirectoryIterator.cpp.

## ◆ getFile()

JUCE_END_IGNORE_WARNINGS_GCC_LIKE JUCE_END_IGNORE_WARNINGS_MSVC const File & juce::DirectoryIterator::getFile | ( |  | ) | const

Returns the file that the iterator is currently pointing at.

The result of this call is only valid after a call to next() has returned true.

Definition at line 138 of file juce_DirectoryIterator.cpp.

## ◆ next() [1/2]

bool juce::DirectoryIterator::next | ( |  | ) |

Moves the iterator along to the next file.

Returns
  true if a file was found (you can then use getFile() to see what it was) - or false if there are no more matching files.

Definition at line 44 of file juce_DirectoryIterator.cpp.

Referenced by next().

## ◆ next() [2/2]

bool juce::DirectoryIterator::next | ( | bool * | isDirectory,
|  | bool * | isHidden,
|  | int64 * | fileSize,
|  | Time * | modTime,
|  | Time * | creationTime,
|  | bool * | isReadOnly )

Moves the iterator along to the next file, and returns various properties of that file.

If you need to find out details about the file, it's more efficient to call this method than to call the normal next() method and then find out the details afterwards.

All the parameters are optional, so pass null pointers for any items that you're not interested in.

Returns
  true if a file was found (you can then use getFile() to see what it was) - or false if there are no more matching files. If it returns false, then none of the parameters will be filled-in.

Definition at line 52 of file juce_DirectoryIterator.cpp.

The documentation for this class was generated from the following files:

- juce_DirectoryIterator.h
- juce_DirectoryIterator.cpp